Index: orxonox/branches/levelloader/src/story_entities/world.h
===================================================================
--- orxonox/branches/levelloader/src/story_entities/world.h	(revision 3606)
+++ orxonox/branches/levelloader/src/story_entities/world.h	(revision 3746)
@@ -8,10 +8,12 @@
 
 #include "stdincl.h"
-
+#include "comincl.h"
 #include "story_entity.h"
 #include "p_node.h"
 
+
+class World;
+class WorldEntity;
 class TrackManager;
-class WorldEntity;
 class Camera;
 class PNode;
@@ -21,5 +23,27 @@
 class FontSet;
 class Terrain;
+class GarbageCollector;
+class SimpleAnimation;
 
+//! The game world Interface
+/**
+   this is a singleton interface, that enables world_entities to access the
+   world. for those objects, there is no easier way than over this interface!
+*/
+class WorldInterface : BaseObject {
+
+ public:
+  ~WorldInterface();
+  static WorldInterface* getInstance();
+  void init(World* world);
+  tList<WorldEntity>* getEntityList();
+
+ private:
+  WorldInterface();
+  static WorldInterface* singletonRef;    //!< singleton reference to this object
+  bool worldIsInitialized;                //!< true if the world has been initialized
+  World* worldReference;                  //!< this is a reference to the running world
+
+};
 
 //! The game world
@@ -39,6 +63,8 @@
   virtual ~World ();
 
+  double getGameTime();
 
   /* classes from story-entity */
+  virtual ErrorMessage preLoad();
   virtual ErrorMessage load ();
   virtual ErrorMessage init ();
@@ -55,4 +81,6 @@
   bool command (Command* cmd);
 
+  tList<WorldEntity>* getEntities();
+
   /* interface to world */
   void spawn (WorldEntity* entity);
@@ -68,11 +96,13 @@
   void init(char* name, int worldID);
 
-  Uint32 lastFrame;             //!< last time of frame
-  bool bQuitOrxonox;            //!< quit this application
-  bool bQuitCurrentGame;        //!< quit only the current game and return to menu
-  bool bPause;                  //!< pause mode
+  Uint32 lastFrame;                   //!< last time of frame
+  Uint32 dt;                          //!< time needed to calculate this frame
+  double gameTime;                    //!< this is where the game time is saved
+  bool bQuitOrxonox;                  //!< quit this application
+  bool bQuitCurrentGame;              //!< quit only the current game and return to menu
+  bool bPause;                        //!< pause mode
 
-  FontSet* testFont;            //!< A test Font. \todo fix this, so it is for real.
-  GLMenuImageScreen* glmis;     //!< The Level-Loader Display
+  FontSet* testFont;                  //!< A test Font. \todo fix this, so it is for real.
+  GLMenuImageScreen* glmis;           //!< The Level-Loader Display
 
   char* worldName;              //!< The name of this World
@@ -80,14 +110,18 @@
   int debugWorldNr;             //!< The Debug Nr. needed, if something goes wrong
 
-  PNode* nullParent;            //!< The zero-point, that everything has as its parent.
-  TrackManager* trackManager;   //!< The reference of the TrackManager that handles the course through the Level.
-  Camera* localCamera;          //!< The current Camera
-  Skysphere* skySphere;         //!< The Environmental Heaven of orxonox \todo insert this to environment insted
-  LightManager* lightMan;       //!< The Lights of the Level
-  Terrain* terrain;             //!< The Terrain of the World.
+  PNode* nullParent;                  //!< The zero-point, that everything has as its parent.
+  TrackManager* trackManager;         //!< The reference of the TrackManager that handles the course through the Level.
+  Camera* localCamera;                //!< The current Camera
+  Skysphere* skySphere;               //!< The Environmental Heaven of orxonox \todo insert this to environment insted
+  LightManager* lightMan;             //!< The Lights of the Level
+  Terrain* terrain;                   //!< The Terrain of the World.
 
-  GLuint objectList;            //!< temporary: \todo this will be ereased soon
-  tList<WorldEntity>* entities;//!< A template List of all entities. Every moving thing should be included here, and world automatically updates them.
-  WorldEntity* localPlayer;     //!< The Player, you fly through the level.
+  GLuint objectList;                  //!< temporary: \todo this will be ereased soon
+  tList<WorldEntity>* entities;       //!< A template List of all entities. Every moving thing should be included here, and world automatically updates them.
+  WorldEntity* localPlayer;           //!< The Player, you fly through the level.
+
+  GarbageCollector* garbageCollector; //!< reference to the garbage  collector
+
+  SimpleAnimation* simpleAnimation;   //!< reference to the SimpleAnimation object
  
   /* function for main-loop */
Index: orxonox/branches/levelloader/src/track_manager.cc
===================================================================
--- orxonox/branches/levelloader/src/track_manager.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/track_manager.cc	(revision 3746)
@@ -18,8 +18,14 @@
 #include "track_manager.h"
 
+#include "base_object.h"
 #include "p_node.h"
 #include "substring.h"
 
 #include "track_node.h"
+#include "stdincl.h"
+#include "list.h"
+#include "debug.h"
+
+
 
 #include <stdarg.h>
@@ -67,10 +73,12 @@
   if ((!this->isJoined &&this->childCount > 0) || (this->isJoined && this->mainJoin))
     {
-      TrackElement* enumElem = children->enumerate();
+      tIterator<TrackElement>* iterator = this->children->getIterator();
+      TrackElement* enumElem = iterator->nextElement();
       while (enumElem)
 	{
 	  delete enumElem;
-	  enumElem = children->nextElement();
-	}
+	  enumElem = iterator->nextElement();
+	}
+      delete iterator;
       delete this->children;
     }
@@ -92,5 +100,6 @@
   if (this->childCount > 0)
     {
-      TrackElement* enumElem = this->children->enumerate();
+      tIterator<TrackElement>* iterator = this->children->getIterator();
+      TrackElement* enumElem = iterator->nextElement();
       TrackElement* tmpElem;
       while (enumElem)
@@ -98,6 +107,7 @@
 	  if ((tmpElem = enumElem->findByID(trackID)))
 	    return tmpElem;
-	  enumElem = this->children->nextElement();
-	}
+	  enumElem = iterator->nextElement();
+	}
+      delete iterator;
     }
   else 
@@ -145,11 +155,13 @@
   else
     {
-      TrackElement* enumElem = this->children->enumerate();
+      tIterator<TrackElement>* iterator = this->children->getIterator();
+      TrackElement* enumElem = iterator->nextElement();
       while (enumElem)
 	{
 	  if(!enumElem->backLoopCheck(trackElem))
 	    return false;
-	  enumElem = this->children->nextElement();
-	}
+	  enumElem = iterator->nextElement();
+	}
+      delete iterator;
       
       return true;
@@ -287,5 +299,5 @@
   PNode* tmpNode = (PNode*)node;
 
-  if (tmpNode->getRelCoor().z < 0)
+  if (tmpNode->getRelCoor()->z < 0)
     return 0;
   else 
@@ -308,5 +320,5 @@
   PNode* tmpNode = (PNode*)node;
 
-  Vector nodeRelCoord = tmpNode->getRelCoor();
+  Vector nodeRelCoord = *tmpNode->getRelCoor();
   float minDist = 100000000;
   int childNumber = 0;
@@ -910,5 +922,4 @@
 void TrackManager::drawGraph(float dt) const
 {
-
   for (int i = 1; i <= trackElemCount; i++)
     {
@@ -922,5 +933,5 @@
 	    glVertex3f(tmpVector.x, tmpVector.y, tmpVector.z);
 	  }
-  glEnd();
+      glEnd();
     }
 }
Index: orxonox/branches/levelloader/src/track_manager.h
===================================================================
--- orxonox/branches/levelloader/src/track_manager.h	(revision 3606)
+++ orxonox/branches/levelloader/src/track_manager.h	(revision 3746)
@@ -12,10 +12,10 @@
 #define _TRACK_MANAGER_H
 
-#include "stdincl.h"
 #include "curve.h"
 #include "substring.h"
+#include "base_object.h"
 
 class PNode;
-class TrackNamer;
+template<class T> class tList;
 
 // Static Definitions
Index: orxonox/branches/levelloader/src/track_node.cc
===================================================================
--- orxonox/branches/levelloader/src/track_node.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/track_node.cc	(revision 3746)
@@ -46,5 +46,5 @@
   this->trackManager = TrackManager::getInstance();
   this->setMode(PNODE_ALL);
-  this->absCoordinate = *absCoordinate;
+  this->absCoordinate = absCoordinate;
 }
 
Index: orxonox/branches/levelloader/src/world_entities/environment.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/environment.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/environment.cc	(revision 3746)
@@ -30,5 +30,6 @@
 Environment::Environment () : WorldEntity()
 {
-  this->model = new OBJModel("../data/models/fighter.obj");
+  this->model = (Model*) ResourceManager::getInstance()->load("cube", RP_LEVEL);
+  //  this->model = new OBJModel("../data/models/fighter.obj");
 }
 
@@ -54,9 +55,9 @@
 	string = grabParameter( root, "model");
 	if( string != NULL)
-		this->model = new OBJModel( string);
+  	this->model = (Model*) ResourceManager::getInstance()->load( string, RP_LEVEL);
 	else
 	{
 		PRINTF0("Environment is missing a proper 'model'\n");
-		this->model = new OBJModel( "../data/models/reaplow.obj");
+  	this->model = (Model*) ResourceManager::getInstance()->load( "cube", RP_LEVEL);
 	}
 	if( this->model == NULL)
Index: orxonox/branches/levelloader/src/world_entities/player.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/player.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/player.cc	(revision 3746)
@@ -20,10 +20,13 @@
 #include "player.h"
 
+#include "track_manager.h"
+#include "objModel.h"
+#include "resource_manager.h"
+#include "weapon.h"
+#include "test_gun.h"
+#include "world.h"
+
+#include "list.h"
 #include "stdincl.h"
-//#include "collision.h"
-#include "objModel.h"
-#include "list.h"
-#include "weapon.h"
-#include "track_manager.h"
 
 using namespace std;
@@ -35,15 +38,23 @@
    \param isFree if the player is free
 */
-Player::Player(bool isFree) : WorldEntity(isFree)
-{
-  this->model = new OBJModel("../data/models/reaplow.obj");
+Player::Player() : WorldEntity()
+{
   this->weapons = new tList<Weapon>();
   this->activeWeapon = NULL;
-
+  /*
+    this is the debug player - actualy we would have to make a new
+     class derivated from Player for each player. for now, we just use
+     the player.cc for debug also
+  */
+  this->model = (Model*)ResourceManager::getInstance()->load("models/reaplow.obj", OBJ, RP_CAMPAIGN);
   travelSpeed = 15.0;
-  velocity = Vector();
+  velocity = new Vector();
   bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
   bFire = false;
   acceleration = 10.0;
+  //weapons:
+  Weapon* wp = new TestGun(this, new Vector(-1.1, 0.0, 2.6), new Quaternion());
+  this->weapons->add(wp);
+  this->activeWeapon = wp;  
 }
 
@@ -53,13 +64,9 @@
 Player::~Player ()
 {
-  Weapon* w = this->weapons->enumerate(); 
-  while( w != NULL) 
-    { 
-      delete w;
-      w = this->weapons->nextElement();
-    }
+  /* do not delete the weapons, they are contained in the pnode tree
+     and will be deleted there.
+     this only frees the memory allocated to save the list.
+  */
   delete this->weapons;
-  
-  //delete this->velocity;
 }
 
@@ -94,9 +101,9 @@
 	string = grabParameter( root, "model");
 	if( string != NULL)
-		this->model = new OBJModel( string);
+  	this->model = (Model*)ResourceManager::getInstance()->load(string, OBJ, RP_CAMPAIGN);
 	else
 	{
 		PRINTF0("Player is missing a proper 'model'\n");
-		this->model = new OBJModel( "../data/models/reaplow.obj");
+  	this->model = (Model*)ResourceManager::getInstance()->load("models/reaplow.obj", OBJ, RP_CAMPAIGN);
 	}
 	if( this->model == NULL)
@@ -104,4 +111,21 @@
 		PRINTF0("Player model '%s' could not be loaded\n", string);
 	}
+	
+	this->weapons = new tList<Weapon>();
+  this->activeWeapon = NULL;
+  /*
+    this is the debug player - actualy we would have to make a new
+     class derivated from Player for each player. for now, we just use
+     the player.cc for debug also
+  */
+  travelSpeed = 15.0;
+  velocity = new Vector();
+  bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
+  bFire = false;
+  acceleration = 10.0;
+  //weapons:
+  Weapon* wp = new TestGun(this, new Vector(-1.1, 0.0, 2.6), new Quaternion());
+  this->weapons->add(wp);
+  this->activeWeapon = wp; 
 }
 
@@ -192,8 +216,10 @@
 void Player::tick (float time)
 {
+  /* link tick to weapon */
+  this->activeWeapon->tick(time);
   // player controlled movement
-  this->move (time);
+  this->move(time);
   // weapon system manipulation
-  this->fire();
+  this->weapon();
 }
 
@@ -214,11 +240,11 @@
   //orthDirection = orthDirection.cross (direction);
 
-  if( this->bUp && this->getRelCoor().x < 20)
+  if( this->bUp && this->getRelCoor()->x < 20)
     accel = accel+(direction*acceleration);
-  if( this->bDown && this->getRelCoor().x > -5)
+  if( this->bDown && this->getRelCoor()->x > -5)
     accel = accel-(direction*acceleration);
-  if( this->bLeft &&  TrackManager::getInstance()->getWidth() > -this->getRelCoor().z*2)
+  if( this->bLeft &&  TrackManager::getInstance()->getWidth() > -this->getRelCoor()->z*2)
     accel = accel - (orthDirection*acceleration); 
-  if( this->bRight &&  TrackManager::getInstance()->getWidth() > this->getRelCoor().z*2)
+  if( this->bRight &&  TrackManager::getInstance()->getWidth() > this->getRelCoor()->z*2)
     accel = accel + (orthDirection*acceleration);
   if( this->bAscend )
@@ -233,15 +259,18 @@
    \brief weapon manipulation by the player
 */
-void Player::fire()
-{
-  if(this->bFire)
+void Player::weapon()
+{
+  if( this->bFire)
     {
       if(this->activeWeapon != NULL)
 	this->activeWeapon->fire();
     }
-  if(this->bWeaponChange)
+  if( this->bWeaponChange && this->weapons->getSize() > 1)
     {
-      Weapon* w = this->weapons->enumerate(); 
+      PRINTF(1)("changing the weapon of the player: deactivate old, activate new\n");
+      this->activeWeapon->deactivate();
+      //this->weapons->enumerate();  FIX: strang weapon change...
       this->activeWeapon = this->weapons->nextElement(this->activeWeapon);
+      this->activeWeapon->activate();
     }
 }
Index: orxonox/branches/levelloader/src/world_entities/player.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/player.h	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/player.h	(revision 3746)
@@ -10,6 +10,7 @@
 
 template<class T> class tList;
-class OBJModel;
 class Weapon;
+class Vector;
+class World;
 
 //! Basic controllable WorldEntity
@@ -19,5 +20,5 @@
   
  public:
-  Player(bool isFree = false);
+  Player();
   Player(TiXmlElement* root);
   virtual ~Player();
@@ -48,11 +49,12 @@
   tList<Weapon>* weapons;//!< a list of weapon
   Weapon* activeWeapon;  //!< the weapon that is currenty activated
+  World* myWorld;        //!< reference to the world object
 
-  Vector velocity;       //!< the velocity of the player.
+  Vector* velocity;       //!< the velocity of the player.
   float travelSpeed;     //!< the current speed of the player (to make soft movement)
   float acceleration;    //!< the acceleration of the player.
   
   void move(float time);
-  void fire(void);
+  void weapon(void);
   
 };
Index: orxonox/branches/levelloader/src/world_entities/projectile.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/projectile.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/projectile.cc	(revision 3746)
@@ -18,8 +18,10 @@
 
 #include "projectile.h"
-#include "stdincl.h"
+
 #include "world_entity.h"
+#include "weapon.h"
+#include "null_parent.h"
+#include "model.h"
 #include "vector.h"
-#include "objModel.h"
 
 using namespace std;
@@ -29,7 +31,12 @@
    \brief standard constructor
 */
-Projectile::Projectile () : WorldEntity()
+Projectile::Projectile (Weapon* weapon) : WorldEntity()
 {
-  this->model = new OBJModel("");
+  this->model = (Model*)ResourceManager::getInstance()->load("sphere", PRIM, RP_LEVEL);
+  this->weapon = weapon;
+  this->flightDirection = NULL;
+  this->currentLifeTime = 0.0f;
+  this->ttl = 0.75f; /* sec */
+  this->speed = 2.0f;
 }
 
@@ -40,7 +47,49 @@
 Projectile::~Projectile () 
 {
-
+  /* 
+     do not delete the test projectModel, since it is pnode 
+     and will be cleaned out by world 
+  */
+  //delete this->projectileModel;
 }
 
+
+/**
+   \brief this sets the flight direction of the projectile
+   \param directin in which to flight
+
+   this function will calculate a vector out of this to be used in the
+   tick function
+*/
+void Projectile::setFlightDirection(Quaternion flightDirection)
+{
+  if( this->flightDirection == NULL)
+    this->flightDirection = new Vector();
+  Vector v(1, 0, 0);
+  *this->flightDirection = flightDirection.apply(v);
+  this->flightDirection->normalize();
+}
+
+
+/**
+   \brief this sets the time to life of the projectile
+   \param ttl in second
+
+   after this life time, the projectile will garbage collect itself
+*/
+void Projectile::setTTL(float ttl)
+{
+  this->ttl = ttl;
+}
+
+
+/**
+   \brief sets the speed of the projectile
+*/
+void Projectile::setSpeed(float speed)
+{
+  this->speed = speed * 3; /* fix speed settings */
+  PRINTF(4)("Projectile::setting speed to: %f\n", this->speed);
+}
 
 /**
@@ -49,5 +98,18 @@
 */
 void Projectile::tick (float time) 
-{}
+{
+  Vector v = *this->flightDirection * ( this->speed * time * 1000 + 0.7);
+  this->shiftCoor(v);
+
+  this->currentLifeTime += time;
+  if( this->ttl < this->currentLifeTime)
+    {
+      PRINTF(5)("FINALIZE==========================\n");
+      PRINTF(5)("current life time is: %f/%f\n", this->currentLifeTime, this->ttl);
+      PRINTF(5)("FINALIZE===========================\n");
+      this->finalize();
+      this->currentLifeTime = 0.0f;
+    }
+}
 
 /**
Index: orxonox/branches/levelloader/src/world_entities/projectile.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/projectile.h	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/projectile.h	(revision 3746)
@@ -2,4 +2,18 @@
     \projectile.h
     \brief a projectile, that is been shooted by a weapon
+
+    You can use this class to make some shoots, but this isn't the real idea. If you want to just test, if the
+    shooting funcions work, use the Projectile class. But if you want to implement your own shoots its 
+    different:<br>
+    Make a new class and derive it from Projectile. To have a weapon work well, reimplement the functions
+    - void tick()
+    - void draw()
+    - void hit() (only if you have working collision detection)
+    When you have implemented these functions you have just to add the projectiles to your weapon. You ll want 
+    to make this by looking into the function 
+    - Weapon::fire()
+    there you just change the line:
+    Projectile* pj = new Projectile();    TO     Projectile* pj = new MyOwnProjectileClass();
+    and schwups it works... :)
 */
 
@@ -9,4 +23,6 @@
 #include "world_entity.h"
 
+class Vector;
+class Weapon;
 
 class Projectile : public WorldEntity 
@@ -15,6 +31,10 @@
 
  public:
-  Projectile ();
+  Projectile (Weapon* weapon);
   virtual ~Projectile ();
+
+  void setFlightDirection(Quaternion flightDirection);
+  void setSpeed(float speed);
+  void setTTL(float ttl);
 
   virtual void hit (WorldEntity* weapon, Vector* loc);
@@ -24,7 +44,12 @@
   virtual void draw ();
 
- private:
+ protected:
   //physical attriutes like: force, speed, acceleration etc.
-
+  float speed;                         //!< this is the speed of the projectile
+  float currentLifeTime;               //!< this is the time, the projectile exists in this world (incremented by tick)
+  float ttl;                           //!< time to life, after this time, the projectile will garbage collect itself
+  Vector* flightDirection;             //!< direction in which the shoot flights
+  Weapon* weapon;                      //!< weapon the shoot belongs to
+  
 };
 
Index: orxonox/branches/levelloader/src/world_entities/skysphere.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/skysphere.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/skysphere.cc	(revision 3746)
@@ -26,9 +26,12 @@
 #define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
 
-#include "material.h"
+
 #include "skysphere.h"
 #include "stdincl.h"
+
+#include "material.h"
 #include "vector.h"
-#include "world_entity.h"
+//#include "world_entity.h"
+
 
 using namespace std;
@@ -100,7 +103,6 @@
   glPushMatrix();
   glMatrixMode(GL_MODELVIEW);
-  glTranslatef(this->absCoordinate.x,
-	       this->absCoordinate.y,
-	       this->absCoordinate.z);
+  Vector r = this->getAbsCoor();
+  glTranslatef(r.x, r.y, r.z);
 
   //glRotatef(-30, 1, 0, 0);
Index: orxonox/branches/levelloader/src/world_entities/skysphere.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/skysphere.h	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/skysphere.h	(revision 3746)
@@ -14,5 +14,4 @@
 
 /* INCLUDES */
-#include "p_node.h"
 #include "world_entity.h"
 
Index: orxonox/branches/levelloader/src/world_entities/terrain.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/terrain.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/world_entities/terrain.cc	(revision 3746)
@@ -16,5 +16,7 @@
 
 #include "terrain.h"
-
+#include "stdincl.h"
+#include "model.h"
+#include "vector.h"
 #include "glincl.h"
 
@@ -43,5 +45,5 @@
   if (strstr(fileName, ".obj") || strstr(fileName, ".OBJ"))
     {
-      this->model = (OBJModel*)new OBJModel(fileName);
+      this->model = (Model*)ResourceManager::getInstance()->load(fileName, OBJ, RP_LEVEL);
     }
   else
Index: orxonox/branches/levelloader/src/world_entities/test_bullet.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/test_bullet.cc	(revision 3746)
+++ orxonox/branches/levelloader/src/world_entities/test_bullet.cc	(revision 3746)
@@ -0,0 +1,100 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer: 
+*/
+
+
+#include "test_bullet.h"
+
+#include "world_entity.h"
+#include "weapon.h"
+#include "null_parent.h"
+#include "model.h"
+#include "vector.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+*/
+TestBullet::TestBullet (Weapon* weapon) : Projectile(weapon)
+{}
+
+
+/**
+   \brief standard deconstructor
+*/
+TestBullet::~TestBullet () 
+{
+  /* 
+     do not delete the test projectModel, since it is pnode 
+     and will be cleaned out by world 
+  */
+  //delete this->projectileModel;
+}
+
+
+
+/**
+   \brief signal tick, time dependent things will be handled here
+   \param time since last tick
+*/
+void TestBullet::tick (float time) 
+{
+  Vector v = *this->flightDirection * ( this->speed * time * 1000 + 0.7);
+  this->shiftCoor(v);
+
+  this->currentLifeTime += time;
+  if( this->ttl < this->currentLifeTime)
+    {
+      PRINTF(5)("FINALIZE==========================\n");
+      PRINTF(5)("current life time is: %f/%f\n", this->currentLifeTime, this->ttl);
+      PRINTF(5)("FINALIZE===========================\n");
+      this->finalize();
+      this->currentLifeTime = 0.0f;
+    }
+}
+
+/**
+   \brief the projectile gets hit by another entity
+   \param the other entity
+   \param place where it is hit
+*/
+void TestBullet::hit (WorldEntity* entity, Vector* place) 
+{}
+
+
+/**
+   \brief the function gets called, when the projectile is destroyed
+*/
+void TestBullet::destroy () 
+{}
+
+
+void TestBullet::draw () 
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  float matrix[4][4];  
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+  this->getAbsDir().matrix (matrix);
+  glMultMatrixf((float*)matrix);  
+  this->model->draw();
+
+  glPopMatrix();
+}
+
Index: orxonox/branches/levelloader/src/world_entities/test_bullet.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/test_bullet.h	(revision 3746)
+++ orxonox/branches/levelloader/src/world_entities/test_bullet.h	(revision 3746)
@@ -0,0 +1,30 @@
+/*! 
+    \projectile.h
+    \brief a projectile, that is been shooted by a weapon
+*/
+
+#ifndef _TEST_BULLET_H
+#define _TEST_BULLET_H
+
+#include "projectile.h"
+
+class Vector;
+class Weapon;
+
+class TestBullet : public Projectile 
+{
+  friend class World;
+
+ public:
+  TestBullet (Weapon* weapon);
+  virtual ~TestBullet ();
+
+  virtual void hit (WorldEntity* weapon, Vector* loc);
+  virtual void destroy ();
+
+  virtual void tick (float time);
+  virtual void draw ();
+  
+};
+
+#endif /* _TEST_BULLET_H */
Index: orxonox/branches/levelloader/src/world_entities/test_gun.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/test_gun.cc	(revision 3746)
+++ orxonox/branches/levelloader/src/world_entities/test_gun.cc	(revision 3746)
@@ -0,0 +1,149 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer: 
+
+
+   \todo: direction in which the projectile flights
+   \todo: a target to set/hit
+*/
+
+
+#include "test_gun.h"
+
+#include "stdincl.h"
+#include "world_entity.h"
+#include "model.h"
+#include "test_bullet.h"
+
+#include "vector.h"
+#include "list.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+
+   creates a new weapon
+*/
+TestGun::TestGun (PNode* parent, Vector* coordinate, Quaternion* direction) 
+  :  Weapon (parent, coordinate, direction) 
+{
+  this->idleTime = 0.2f;
+}
+
+
+/**
+   \brief standard deconstructor
+*/
+TestGun::~TestGun () 
+{
+  // model will be deleted from WorldEntity-destructor
+}
+
+
+/**
+   \brief this activates the weapon
+
+   This is needed, since there can be more than one weapon on a ship. the 
+   activation can be connected with an animation. for example the weapon is 
+   been armed out. 
+*/
+void TestGun::activate()
+{}
+
+
+/**
+   \brief this deactivates the weapon
+
+   This is needed, since there can be more than one weapon on a ship. the 
+   activation can be connected with an animation. for example the weapon is 
+   been armed out.
+*/
+void TestGun::deactivate()
+{}
+
+
+/**
+   \brief fires the weapon
+   
+   this is called from the player.cc, when fire-button is been pushed
+*/
+void TestGun::fire()
+{
+  if( this->localTime < this->idleTime)
+    {
+      this->weaponIdle();
+      return;
+    }
+  Projectile* pj = new TestBullet(this);
+
+  pj->setAbsCoor(this->getAbsCoor());
+  pj->setAbsDir(this->getAbsDir());
+
+  pj->setFlightDirection(this->getAbsDir());
+  pj->setSpeed(this->getSpeed());
+
+  this->worldEntities->add(pj);
+  this->localTime = 0;
+}
+
+
+/**
+   \brief is called, when the weapon gets hit (=collide with something)
+   \param from which entity it is been hit
+   \param where it is been hit
+
+   this may not be used, since it would make the game relay complicated when one
+   can destroy the weapons of enemies or vice versa.
+*/
+void TestGun::hit (WorldEntity* entity, Vector* position) 
+{}
+
+
+/**
+   \brief is called, when the weapon is destroyed
+
+   this is in conjunction with the hit function, so when a weapon is able to get
+   hit, it can also be destoryed.
+*/
+void TestGun::destroy () 
+{}
+
+
+/**
+   \brief tick signal for time dependent/driven stuff
+*/
+void TestGun::tick (float time) 
+{
+  this->localTime += time;
+  //this->debug();
+  //printf("TEST_GUN: this speed is: %f\n", this->getSpeed());
+}
+
+
+/**
+   \brief is called, when there is no fire button pressed
+*/
+void TestGun::weaponIdle()
+{}
+
+
+/**
+   \brief this will draw the weapon
+*/
+void TestGun::draw () 
+{}
+
Index: orxonox/branches/levelloader/src/world_entities/test_gun.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/test_gun.h	(revision 3746)
+++ orxonox/branches/levelloader/src/world_entities/test_gun.h	(revision 3746)
@@ -0,0 +1,54 @@
+/*! 
+    \file weapon.h
+    \brief a weapon that a player can use
+
+    A Player has a list of weapons, that can be choosen to shoot projectiles
+    (projectiles.{cc,h}) at ennemies. These weapons can be shooted sequentially
+    or (if able) combined. Therefore you can choose the weapon mode = choose
+    a weapon.
+
+    A weapon is characterized by:
+     o firing-rate: the initial firing rate of a weapon (1/s = Herz)
+     o slowdown-factor: this is a factor d: exp(-d*x), d is element of all positive R. it determines how fast the firing-rate will slow down. if no slowdown: d=0, the bigger d is, the faster the weapon will slow down!
+     o energy-consumption: this determines the energy that has to be used to produce this projectile = costs per projectile
+    
+    Furthermore there are some other attributes, that will help to represent a firing
+    weapon in this world:
+     o sound file/ressource: this is a pointer to the sound-file/ressource. however it may be represented
+     o shooting animation
+     
+*/
+
+
+#ifndef _TEST_GUN_H
+#define _TEST_GUN_H
+
+#include "weapon.h"
+
+class Projectile;
+class Vector;
+class Quaternion;
+
+
+class TestGun : public Weapon
+{
+  friend class World;
+
+ public:
+  TestGun (PNode* parent, Vector* coordinate, Quaternion* direction);
+  virtual ~TestGun ();
+
+  virtual void activate(void);
+  virtual void deactivate(void);
+
+  virtual void fire(void);
+  virtual void hit (WorldEntity* weapon, Vector* loc);
+  virtual void destroy(void);
+  
+  virtual void tick(float time);
+  virtual void weaponIdle(void);
+  virtual void draw(void);
+
+};
+
+#endif /* _TEST_GUN_H */
